package com.objsys.asn1c.validator;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

public class StreamHandler implements Runnable {
  private BufferedReader inputStreamReader;
  private StringBuffer output;
  private final LineProcessor lineProcessor;

  public StreamHandler(InputStream inputStream, LineProcessor lineProcessor) {
    this.lineProcessor = lineProcessor;
    inputStreamReader = new BufferedReader(new InputStreamReader(inputStream));
    output = new StringBuffer();
  }

  public void run() {
    try {
      for (String line; (line = inputStreamReader.readLine()) != null;) {
        output.append(line).append('\n');
        lineProcessor.process(line);
      }
    } catch (Exception e) {
      e.printStackTrace();
      // TODO: handle exception
    }
  }

  public String getOutput() {
    return output.toString();
  }
}