package com.objsys.asn1c.validator.preferences;

import net.sourceforge.asneditor.ui.preferences.common.AbstractConfigurationBlockPreferencePage;
import net.sourceforge.asneditor.ui.preferences.common.IPreferenceConfigurationBlock;
import net.sourceforge.asneditor.ui.preferences.common.OverlayPreferenceStore;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import com.objsys.asn1c.Activator;


/**
 * Provides for preference page in Workbench's general preferences 
 * (Window > Preferences) by contributing to org.eclipse.ui.preferencePages 
 * extension point. 
 * 
 *
 */
public class ASN1CPreferencePage extends AbstractConfigurationBlockPreferencePage {

  @Override
  protected IPreferenceConfigurationBlock createConfigurationBlock(
      OverlayPreferenceStore overlayPreferenceStore) {
    return new ASN1CConfigurationBlock(overlayPreferenceStore);
  }

  @Override
  protected void setPreferenceStore() {
    setPreferenceStore(Activator.getDefault().getPreferenceStore());
  }

  @Override
  protected String getHelpId() {
    return null;
  }

  @Override
  protected void setDescription() {
    String description= Messages.ASN1CPreferencePage_asn1cTitle;
    setDescription(description);
  }

  protected Label createDescriptionLabel(Composite parent) {
    return null; // no description for new look.
  }

  public boolean performOk() {
    boolean performOk = super.performOk();
    Activator.getDefault().savePluginPreferences();
    return performOk;
  }
}
