package com.objsys.asn1c.validator.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.core.runtime.preferences.DefaultScope;
import org.eclipse.core.runtime.preferences.IEclipsePreferences;

import com.objsys.asn1c.Activator;

/**
 * Initializes the default scope preferences for the plug-in.
 * Contributes to org.eclispe.core.runtime.preferences extension point.
 * @author Kevin
 *
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

   public PreferenceInitializer() {
      super();
   }   
   
   @Override
   public void initializeDefaultPreferences() {
      String plugInId = Activator.getDefault().getBundle().getSymbolicName();
      
      IEclipsePreferences node = new DefaultScope().getNode(plugInId);
      ASN1CPreferenceConstants.loadDefaults(node);      
   }



}
