package com.objsys.asn1c.validator.wizard;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;

public class FileUtils {

  public static void copy(String inputFilename, String outputFilename) throws IOException {
    copy(new File(inputFilename), new File(outputFilename));
  }

  public static void copy(File input, File output) throws IOException {
    if (input.isDirectory() && output.isDirectory()) {
      copyDir(input, output);
    } else {
      copyFile(input, output);
    }
  }

  public static void copyFile(File inputFile, File outputFile) throws IOException {
    BufferedInputStream fr = new BufferedInputStream(new FileInputStream(inputFile));
    BufferedOutputStream fw = new BufferedOutputStream(new FileOutputStream(outputFile));
    byte[] buf = new byte[8192];
    int read;
    while ((read = fr.read(buf)) >= 0)
      fw.write(buf, 0, read);
    fr.close();
    fw.close();
  }

  public static void copyDir(File inputDir, File outputDir) throws IOException {
    File[] files = inputDir.listFiles();
    for (int i = 0; i < files.length; i++) {
      File destFile = new File(outputDir.getAbsolutePath() + File.separator + files[i].getName());
      if (!destFile.exists()) {
        if (files[i].isDirectory()) {
          destFile.mkdir();
        }
      }
      copy(files[i], destFile);
    }
  }
  /**
   * @return true if location represents a path inside the workspace
   */
  public static boolean isInWorkspace(String location) {
    IPath projectPath= Path.fromOSString(location);
    return Platform.getLocation().isPrefixOf(projectPath);
  }
}
