package com.objsys.asn1c.validator.wizard;

import net.sourceforge.asneditor.ui.preferences.common.AbstractConfigurationBlock;
import net.sourceforge.asneditor.ui.preferences.common.ScrolledPageContent;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

import com.objsys.asn1c.validator.preferences.ASN1CConfigurationBlock;
import com.objsys.asn1c.validator.project.ACProject;


public class LanguageWizardPage extends WizardPage {
  private ASN1CConfigurationBlock configurationBlock;

  protected LanguageWizardPage(ACProject acproject, ASN1CConfigurationBlock configurationBlock) {
    super("LanguageWizardPage"); //$NON-NLS-1$
    this.configurationBlock = configurationBlock;
    setTitle(Messages.LanguageWizardPage_title);
    setDescription(Messages.LanguageWizardPage_description);
  }

  public void createControl(Composite parent) {
    ScrolledPageContent scrolled= new ScrolledPageContent(parent);
    scrolled.setExpandHorizontal(true);
    scrolled.setExpandVertical(true);

    Composite rootComposite= scrolled.getBody();
    GridLayout layout= new GridLayout();
    layout.marginWidth= 0;
    layout.marginHeight= 0;
    rootComposite.setLayout(layout);
    scrolled.setContent(rootComposite);

    Group group;
    Composite composite;

    group = new Group(rootComposite, SWT.NONE);
    group.setText(com.objsys.asn1c.validator.preferences.Messages.ASN1CConfigurationBlock_language);
    group.setLayoutData(new GridData(GridData.FILL, GridData.BEGINNING, true, false));
    AbstractConfigurationBlock.applyGridLayout(1, group);
    composite = AbstractConfigurationBlock.createComposite(group, 1);
    configurationBlock.addLanguageSection(composite);

    // initialize fields only after their creation
    configurationBlock.initialize();

    setControl(scrolled);
  }

}
