package com.objsys.asn1c.validator.wizard;

import net.sourceforge.asneditor.ui.preferences.common.AbstractConfigurationBlock;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import com.objsys.asn1c.validator.ValidationUtils;
import com.objsys.asn1c.validator.project.ACProject;

public class LaunchWizardPage extends WizardPage {

  private Text cmdLineText;
  private ACProject acproject;
  private IPropertyChangeListener propertyChangeListener;
  private Button compileButton;

  protected LaunchWizardPage(ACProject acproject) {
    super("LaunchWizardPage"); //$NON-NLS-1$
    this.acproject = acproject;
    setTitle(Messages.LaunchWizardPage_title);
    setDescription(Messages.LaunchWizardPage_description);
  }

  public void createControl(Composite parent) {
    Composite composite = new Composite(parent, SWT.NONE);
    GridData gd = new GridData(GridData.FILL, GridData.FILL, true, true);
    composite.setLayoutData(gd);
    composite.setLayout(new GridLayout());

    cmdLineText = new Text(composite, SWT.MULTI | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
    cmdLineText.setEditable(false);
    gd = new GridData(GridData.FILL, GridData.FILL, true, true);
    cmdLineText.setLayoutData(gd);
    propertyChangeListener = new IPropertyChangeListener(){
      public void propertyChange(PropertyChangeEvent event) {
        dialogChanged();
      }};
    acproject.getPreferenceStore().addPropertyChangeListener(propertyChangeListener);

    Composite local = AbstractConfigurationBlock.createComposite(composite, 3);
    compileButton = new Button(local, SWT.CHECK);
    compileButton.setText(Messages.LaunchWizardPage_compile);
    gd= new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
    compileButton.setLayoutData(gd);

    dialogChanged();
    setControl(composite);
  }

  private void dialogChanged() {
    if (cmdLineText == null || cmdLineText.isDisposed() || acproject == null) {
      return;
    }
    cmdLineText.setText(ValidationUtils.getCommandLineParameters(acproject, null, 100));
  }

  public void dispose() {
    acproject.getPreferenceStore().removePropertyChangeListener(propertyChangeListener);
    super.dispose();
  }

  public boolean shouldGenerate() {
    return compileButton.getSelection();
  }
}
